<template>
  <div class="page-container list-container">
    <!-- 功能按钮区 -->
    <div class="list-btns-container">
      <el-button type="success" size="small" icon="Refresh" @click="getList"
        v-hasPermi="['business:entrustOrder:remove']">刷新</el-button>
      <el-dropdown trigger="click">
        <el-button type="primary" size="small">
          其它<el-icon class="el-icon--right"><arrow-down /></el-icon>
        </el-button>
        <template #dropdown>
          <el-dropdown-menu>
            <el-dropdown-item icon="Download" @click="handleExport" v-if="viewAdviser('business:entrustOrder:export')">
              导出</el-dropdown-item>
          </el-dropdown-menu>
        </template>
      </el-dropdown>
    </div>
    <!-- 搜索区 -->
    <el-form class="list-search-container" size="small" :model="queryParams" ref="queryRef" :inline="true"
      label-width="68px" @submit.native.prevent>
      <el-form-item label="往来单位：" prop="contactCompany">
        <el-input v-model="queryParams.contactCompany" placeholder="请输入往来单位" clearable @keyup.enter="handleQuery"
          style="width: 150px" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 列表区 -->
    <el-table v-loading="loading" :data="list" size="small" border height="100%"
      @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="签约日期" align="center" prop="formDate" width="150" />
      <el-table-column label="合同编号" align="center" prop="formNo" width="120">
      </el-table-column>
      <el-table-column label="往来单位" align="center" prop="contactCompany" width="140">
      </el-table-column>
      <el-table-column label="预存金额" prop="depositAmount" align="center" width="100">
        <template #default="scope">
          <span>{{ rowNum(scope.row.depositAmount) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="结余金额" prop="remainAmount" align="center" width="100">
        <template #default="scope">
          <span>{{ rowNum(scope.row.remainAmount) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" prop="remark" align="center">
      </el-table-column>
      <el-table-column label="状态" prop="status" align="center" width="100">
        <template #default="scope">
          <dict-tag :options="entrust_order_status" :value="scope.row.status" />
        </template>
      </el-table-column>
    </el-table>
    <entrust-order-form ref="entrustOrderFormRef" :getList="getList" />
    <!-- 分页 -->
    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />
  </div>
</template>

<script setup name="General">
  import {
    listEntrustOrder,
    exportEntrustOrder,
    delEntrustOrder,
    confirmEntrustOrder,
    finishedEntrustOrder,
  } from "@/api/business/entrust/entrustOrder";
  import { rowNum } from "@/utils/index";
  import useUserStore from "@/store/modules/user";
  import entrustOrderForm from "./form";
  const { proxy } = getCurrentInstance();
  /** 字典数组区 */
  /** 查询 对象 */

  const list = ref([]);
  const loading = ref(true);
  const ids = ref([]);
  const selections = ref([]);
  const single = ref(false);
  const multiple = ref(false);
  const permissions = useUserStore().permissions;
  const all_permission = "*:*:*";
  const total = ref(0);
  const prev = ref([]);
  const entrustOrderFormRef = ref(null);

  const setEntrustDialogRef = ref(null);

  const { entrust_order_status } = proxy.useDict("entrust_order_status");
  /** 查询对象 */
  const queryParams = ref({
    pageNum: 1,
    pageSize: 20,
    contactCompany: "",
    type: 2,
  });

  const editStatus = {
    startMonth: false,
  };

  /***********************  方法区  ****************************/
  onActivated(() => {
    // 你的逻辑
    getList();
  });
  /** 查询company列表 */
  function getList() {
    loading.value = true;
    listEntrustOrder(queryParams.value).then((response) => {
      list.value = response.rows;
      total.value = response.total;
      loading.value = false;
    });
  }

  //判断是否有权限
  function viewAdviser(quer) {
    return permissions.includes(all_permission) || permissions.includes(quer);
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1;
    getList();
  }

  /** 重置按钮操作 */
  function resetQuery() {
    proxy.resetForm("queryRef");
    handleQuery();
  }

  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map((item) => item.id);
    selections.value = selection;
    single.value = selection.length != 1;
    multiple.value = selection.length > 0;
  }

  /** 导出按钮操作 */
  function handleExport() {
    exportEntrustOrder(queryParams.value);
  }

  /** 新增按钮操作 */
  function handleAdd() {
    entrustOrderFormRef.value.open();
  }

  function handleUpdate(id) {
    entrustOrderFormRef.value.open(id);
  }

  /** 删除按钮操作 */
  function handleDelete(row) {
    const _ids = row.id || ids.value;
    proxy.$modal
      .confirm("是否确认删除选中的数据项？")
      .then(function () {
        return delEntrustOrder(_ids);
      })
      .then(() => {
        getList();
        proxy.$modal.msgSuccess("删除成功！");
      })
      .catch(() => { });
  }

  function handleConfirm(row) {
    proxy.$modal
      .confirm("确认启用该合同？")
      .then((_) => {
        return confirmEntrustOrder(row);
      })
      .then((res) => {
        console.log(res);
        getList();
        proxy.$modal.msgSuccess("确认成功");
      });
  }

  function handleFinished(row) {
    proxy.$modal
      .confirm("确认完结该合同？")
      .then((_) => {
        return finishedEntrustOrder(row);
      })
      .then((res) => {
        console.log(res);
        getList();
        proxy.$modal.msgSuccess("完结成功");
      });
  }

  function handleViewAccountment(row) { }

  getList();
</script>